package require Tk

#main Frame
wm title . {tkSynthesize}
grid [ttk::frame .mf -padding "5 5 5 5"] -sticky nwes

#source file + selection dialog
grid [ttk::label .mf.sourcel -text {Source}] -column 1 -row 1 -sticky we -padx 5 -pady 5
grid [ttk::entry .mf.source -width 50 -textvariable source] -column 2 -row 1 -sticky we -padx 5 -pady 5
grid [ttk::button .mf.sourcefs -width 2 -text {...} -command loadFile] -column 3 -row 1 -sticky w -padx 5 -pady 5

#destination file + selection dialog
grid [ttk::label .mf.destinationl -text {Destination}] -column 1 -row 2 -sticky we -padx 5 -pady 5
grid [ttk::entry .mf.destination -width 50 -textvariable destination] -column 2 -row 2 -sticky we -padx 5 -pady 5
grid [ttk::button .mf.destinationfs -width 2 -text {...} -command saveFile] -column 3 -row 2 -sticky w -padx 5 -pady 5

#minimization algorithm chooser
grid [ttk::label .mf.minimizationl -text {State minimizaton algorithm}] -column 1 -row 3 -sticky we -padx 5 -pady 5
set minimizationChoice [eda synthesize getStateMinimizationAlgorithms]
grid [ttk::combobox .mf.minimization -textvariable minimization -values $minimizationChoice -state readonly] -column 2 -row 3 -sticky we -padx 5 -pady 5
#set minimization {noMinimization}

#encoding algorithm chooser
grid [ttk::label .mf.encodingl -text {Encoding algorithm}] -column 1 -row 4 -sticky we -padx 5 -pady 5
set encodingChoice  [eda synthesize getEncodingAlgorithms]
grid [ttk::combobox .mf.encoding -textvariable encoding -values $encodingChoice -state readonly] -column 2 -row 4 -sticky we -padx 5 -pady 5
#set encoding {binary}

#realization algorithm chooser
grid [ttk::label .mf.realizationl -text {Realization algorithm}] -column 1 -row 5 -sticky we -padx 5 -pady 5
set realizationChoice  [eda synthesize getRealizationAlgorithms]
grid [ttk::combobox .mf.realization -textvariable realization -values $realizationChoice -state readonly] -column 2 -row 5 -sticky we -padx 5 -pady 5
#set realization {naive}

#SYNTHESIZE button
grid [ttk::button .mf.synthesize -text {Synthesize} -command synthesize -default active] -column 2 -row 10 -sticky e -padx 5 -pady 5

proc synthesize {} {
	set intSrc {main:fsm..fsm}
	set intDest {struct.circuit.seq}

	eda import $::source $intSrc
	eda synthesize $intSrc $intDest $::minimization $::encoding $::realization
	eda export $::destination $intDest
	#eda export dbg.dbg

#TODO error check

	tk_messageBox -title {Hotovo!} -message "Syntza byla dokonena.\n eda synthesize $intSrc $intDest $::minimization $::encoding $::realization"
}

proc loadFile {} {
	set extensions {
		{{kiss files}    {.kiss .kiss2}}
		{{blif files}    {.blif}}
		{{All FSM files} {.kiss .kiss2 .blif}}
	}

	set defaultExt {All FSM files}
	set ::source [tk_getOpenFile -parent . -filetypes $extensions -typevariable defaultExt]
}

proc saveFile {} {
	set extensions {
		{{vhdl files}     {.vhdl .vhd}}
		{{blif files}     {.blif}}
		{{debuging files} {.dbg}}
		{{All gate files} {.vhdl .blif .edif .dbg}}
	}

	set defaultExt {debuging files}
	set ::destination [tk_getSaveFile -parent . -filetypes $extensions -typevariable defaultExt]
}
