#include "StateMinimizer.h"

StateMinimizer::StateMinimizer( hub::Hub* theHub ) : theHub(theHub) {
}

StateMinimizer::~StateMinimizer(){
}

void StateMinimizer::operator()( hub::SrcLocation& src, hub::DestLocation& dest, StateMinimizationAlgorithmID algorithmID ){
	using namespace hub;

	const BehavArch* srcArch = src.theArch()->Impl<BehavArch>();
	const FsmDescr* srcFSM = srcArch->description<FsmDescr>();

	if( (std::string)src != (std::string)dest ){
		dest.theArch()->Impl( new BehavArch );
		BehavArch* destArch = dest.theArch()->Impl<BehavArch>();
		destArch->description( new FsmDescr );

		//copy ports
		for( hub::Entity::PortProtoIter it = src.theEntity()->PortProtoBeg(); it != src.theEntity()->PortProtoEnd(); it++ ){
			dest.theEntity()->CreateNextPort( it->first, it->second->flags() );
		}
	}

	FsmDescr* destFSM = dest.theArch()->Impl<BehavArch>()->description<FsmDescr>();

	switch( algorithmID ){
		///////////////////////////////////////////////////
		//add your new algorithm implementation call here//
		///////////////////////////////////////////////////
		case noMinimization: this->doNoMinimization( srcFSM, destFSM ); break;
		case super: this->doMegaSuperSmartAlgorithm( srcFSM, destFSM ); break;
	}
}

void StateMinimizer::doNoMinimization( const hub::FsmDescr* srcFSM, hub::FsmDescr* destFSM ){
	destFSM->copy( *srcFSM );
}

void StateMinimizer::doMegaSuperSmartAlgorithm( const hub::FsmDescr* srcFSM, hub::FsmDescr* destFSM ){
	destFSM->copy( *srcFSM );
}
