//class implementing state MINIMIZATION module
//	-module optimizing FSM by removing redundant states.
//author: Petr Kraus
//////////////////////////////////////////////////////////////////////////

#ifndef STATEMINIMIZER_H
#define STATEMINIMIZER_H

#pragma warning( push )
#pragma warning( disable: 4996 4100 )	//usage of old stricmp and unreferenced parameter e in hub.h
#include "hub/hub.h"

#include "hub/location.h"
#include "hub/behavioral.h"
#include "hub/fsm.h"
#pragma warning( pop )

#include "Algorithms.h"

class StateMinimizer{
	hub::Hub* theHub;

	//////////////////////////////////////////////
	//add your new algorithm implementation here//
	//////////////////////////////////////////////

	//perform no optimalization. All states are included in destination
	void doNoMinimization( const hub::FsmDescr* srcFSM, hub::FsmDescr* destFSM );
	void doMegaSuperSmartAlgorithm( const hub::FsmDescr* srcFSM, hub::FsmDescr* destFSM );

public:
	StateMinimizer( hub::Hub* theHub );
	~StateMinimizer();

	void operator() ( hub::SrcLocation& src, hub::DestLocation& dest, StateMinimizationAlgorithmID algorithmID );
};

#endif
