//Header containing standardized ENCODING algorithms identifications.
//Encoding module is implemented before by Jan Egert. This module uses string identificator and doesnt use the enum id.
//author: Petr Kraus
//////////////////////////////////////////////////////////////////////////

#ifndef FSMENCODEALGORTHMS_H
#define FSMENCODEALGORTHMS_H

/////////////////////////////////////////
//enumerate your new algorithm(s) here.//
//DO NOT delete lastE!!				   //
/////////////////////////////////////////
enum EncodingAlgorithmID { own, binary, onehot, s_onehot, zerohot, s_zerohot, random, brute, twohots, johnson, lastE };

//////////////////////////////////////////////////////////////////////////////////////
//add your new algorithm identificator instance in array here						//
//with extended description, string identification and enum element added above		//
//DO NOT delete lastE!!																//
//////////////////////////////////////////////////////////////////////////////////////
#define ENCODING_ALGORITHMS	\
const EncodingAlgorithmIdentificator ENCODING_ALGORITHMS_CHOICE[] = { EncodingAlgorithmIdentificator( "Jan Egert's coding", "own", own ),	\
														   EncodingAlgorithmIdentificator( "binary coding", "binary", binary ),	\
														   EncodingAlgorithmIdentificator( "one-hot coding", "onehot", onehot ),	\
														   EncodingAlgorithmIdentificator( "one-hot coding starting 000...", "s_onehot", s_onehot ),	\
														   EncodingAlgorithmIdentificator( "zero-hot coding", "zerohot", zerohot ),	\
														   EncodingAlgorithmIdentificator( "zero-hot coding starting 111...", "s_zerohot", s_zerohot ),	\
														   EncodingAlgorithmIdentificator( "random coding", "random", random ),	\
														   EncodingAlgorithmIdentificator( "brute force", "brute", brute ),	\
														   EncodingAlgorithmIdentificator( "two-hots coding", "twohots", twohots ),	\
														   EncodingAlgorithmIdentificator( "unoptimized Johnson's coding", "johnson", johnson ),	\
														   EncodingAlgorithmIdentificator( "end of array", "lastE", lastE )	\
														 }; 

#endif
